<template>
    <div
        class="w-full"
    >
        <div
            class="px-3 my-4 w-full lg:max-w-[400px] lg:mx-auto"
        >
            <div class="pl-2 font-black capitalize">{{ $t('personal_buy_in_portfolio') }}</div>
            <div
                class="w-full rounded-lg bg-neutral text-white p-2 mb-4"
            >
                <div class="max-w-[160px]">
                    <form-input
                        v-model="personalBuyInAmount"
                        name="personal_buy_in_amount"
                        :label="$t('buy_in_amount')"
                        dollar-sign fund dark
                    />
                </div>
                <div
                    class="mt-3 grid grid-cols-5 gap-1 items-center"
                >
                    <div class="col-span-2">
                        <div class="text-[11px]">{{ $t('assumed_monthly_roi') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(personalAssumeMonthlyRoi) }}</div>
                        </div>
                    </div>
                    <div class="col-span-2">
                        <div class="text-[11px]">{{ $t('assumed_monthly_income') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(personalAssumeMonthlyIncome) }}</div>
                        </div>
                    </div>
                    <div
                        class="text-2xl self-center place-self-center text-center text-green-300"
                    >
                        <template
                            v-if="personalAssumeMonthlyPercentage > 0"
                        >
                            {{ $helper.fundFormat(personalAssumeMonthlyPercentage, 0) }}
                        </template>
                        <template
                            v-else
                        >
                            -
                        </template>
                        %
                    </div>
                </div>
            </div>
            <div class="pl-2 font-black capitalize">{{ $t('direct_referral_bonus_drb') }}</div>
            <div
                class="w-full rounded-lg bg-neutral text-white p-2 mb-4 relative"
            >
                <div
                    class="absolute inset-y-2 right-2"
                >
                    <div
                        class="bg-slate-600 text-slate-300 px-3 py-1.5 rounded-lg font-black mb-3"
                    >
                        {{ drbPercentage }}%
                    </div>
                </div>
                <div class="max-w-[160px] mt-3">
                    <form-input
                        v-model="drbDirectReferredPax"
                        name="personal_buy_in_amount"
                        :label="$t('direct_referred_pax')"
                        fund dark
                    />
                </div>
                <div
                    class="mt-3 grid grid-cols-5 gap-1 items-center"
                >
                    <div class="col-span-2">
                        <div class="text-xs">{{ $t('monthly_drb_earned') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(drbMonthlyEarned) }}</div>
                        </div>
                    </div>
                    <div class="col-span-2">
                        <div class="text-xs">{{ $t('monthly_income') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(drbMonthlyIncome) }}</div>
                        </div>
                    </div>
                    <div
                        class="text-2xl self-center place-self-center text-center text-green-300"
                    >
                        <template
                            v-if="drbMonthlyPercentage > 0"
                        >
                            {{ $helper.fundFormat(drbMonthlyPercentage, 0) }}
                        </template>
                        <template
                            v-else
                        >
                            -
                        </template>
                        %
                    </div>
                </div>
            </div>
            <div class="pl-2 font-black capitalize">{{ $t('business_manager_bonus_bmb') }}</div>
            <div
                class="w-full rounded-lg bg-neutral text-white p-2 mb-4"
            >
                <div
                    class="flex justify-between space-x-2"
                >
                    <div
                        class="flex justify-start space-x-1 items-center"
                    >
                        <a
                            href="javascript:"
                            class="px-3 rounded-full py-1.5 cursor-pointer border cursor-pointer text-center border-white"
                            :class="{
                                'text-white bg-neutral': bmbRankingSet !== 1,
                                'bg-white text-neutral': bmbRankingSet === 1,
                            }"
                            @click="bmbRankingSet = 1"
                        >
                            {{ $t('bm1') }}
                        </a>
                        <a
                            href="javascript:"
                            class="px-3 rounded-full py-1.5 cursor-pointer border cursor-pointer text-center border-white"
                            :class="{
                                'text-white bg-neutral': bmbRankingSet !== 2,
                                'bg-white text-neutral': bmbRankingSet === 2,
                            }"
                            @click="bmbRankingSet = 2"
                        >
                            {{ $t('bm2') }}
                        </a>
                        <a
                            href="javascript:"
                            class="px-3 rounded-full py-1.5 cursor-pointer border cursor-pointer text-center border-white"
                            :class="{
                                'text-white bg-neutral': bmbRankingSet !== 3,
                                'bg-white text-neutral': bmbRankingSet === 3,
                            }"
                            @click="bmbRankingSet = 3"
                        >
                            {{ $t('bm3') }}
                        </a>
                    </div>
                    <div
                        class="bg-slate-600 text-slate-300 px-3 py-1.5 rounded-lg font-black mb-3"
                    >
                        {{ bmbPercentage }}%
                    </div>
                </div>
                <div class="max-w-[160px]">
                    <form-input
                        v-model="bmbInvestorPax"
                        name="bmb_investor_pax"
                        :label="$t('investor_pax')"
                        fund dark
                    />
                </div>
                <div
                    class="mt-3 grid grid-cols-5 gap-1 items-center"
                >
                    <div class="col-span-2">
                        <div class="text-xs">{{ $t('monthly_bmb_earned') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(bmbMonthlyEarned) }}</div>
                        </div>
                    </div>
                    <div class="col-span-2">
                        <div class="text-xs">{{ $t('monthly_income') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(bmbMonthlyIncome) }}</div>
                        </div>
                    </div>
                    <div
                        class="text-2xl self-center place-self-center text-center text-green-300"
                    >
                        <template
                            v-if="drbMonthlyPercentage > 0"
                        >
                            {{ $helper.fundFormat(bmbMonthlyPercentage, 0) }}
                        </template>
                        <template
                            v-else
                        >
                            -
                        </template>
                        %
                    </div>
                </div>
            </div>
            <div class="pl-2 font-black capitalize">{{ $t('business_manager_incentives_bmi') }}</div>
            <div
                class="w-full rounded-lg bg-neutral text-white p-2 mb-4"
            >
                <div
                    class="flex justify-end"
                >
                    <div
                        class="bg-slate-600 text-slate-300 px-3 py-1.5 rounded-lg font-black mb-3"
                    >
                        {{ bmiPercentage }}%
                    </div>
                </div>
                <div
                    class="grid grid-cols-3 gap-1 items-center"
                >
                    <form-input
                        v-model="bmiDirectReferredPax"
                        type="number"
                        name="bmb_direct_refer_pax"
                        :label="$t('direct_refer')"
                        number dark
                    />
                    <form-input
                        v-model="bmiGensPax"
                        type="number"
                        name="bmi_gens"
                        :label="$t('gen_s')"
                        number dark
                    />
                    <form-input
                        v-model="bmiBmPerGenPax"
                        type="number"
                        name="bmi_bm_per_gen"
                        :label="$t('bm_per_gen')"
                        number dark
                    />
                </div>
                <div
                    class="mt-3 grid grid-cols-3 gap-1 items-center"
                >
                    <div>
                        <div class="text-xs">{{ $t('monthly_bmi_earned') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(bmiMonthlyEarned, 0) }}</div>
                        </div>
                    </div>
                    <div>
                        <div class="text-xs">{{ $t('monthly_income') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(bmiMonthlyIncome, 0) }}</div>
                        </div>
                    </div>
                    <div>
                        <div class="text-xs">{{ $t('yearly_income') }}</div>
                        <div
                            class="input-box sm disabled flex justify-start space-x-2"
                        >
                            <span>$</span>
                            <div>{{ $helper.fundFormat(bmiYearlyIncome, 0) }}</div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {ref, computed} from "vue";
import FormInput from "~/components/form/form-input.vue";
import BigNumber from "bignumber.js";

const personalBuyInAmount = ref('');
const personalAssumeMonthlyRoi = computed(() => {
    if (parseFloat(personalBuyInAmount.value) <= 0) return 0;
    return new BigNumber(personalBuyInAmount.value).div(100).times(personalAssumeMonthlyPercentage.value).toNumber();
});
const personalAssumeMonthlyIncome = computed(() => {
    return personalAssumeMonthlyRoi.value;
});
const personalAssumeMonthlyPercentage = computed(() => {
    if (parseFloat(personalBuyInAmount.value) <= 0) {
        return 0;
    }
    return 20;
});

const drbDirectReferredPax = ref('');
const drbPercentage = computed(() => {
    if (!personalBuyInAmount.value || parseFloat(personalBuyInAmount.value) <= 0) return 0;
    let t = new BigNumber(drbDirectReferredPax.value);
    if (t.gte(5)) return 15;
    else if (t.gte(4)) return 14;
    else if (t.gte(3)) return 13;
    else if (t.gte(2)) return 12;
    else if (t.gte(1)) return 11;
    else return 11;
});
const drbMonthlyEarned = computed(() => {
    if (!personalBuyInAmount.value || parseFloat(personalBuyInAmount.value) <= 0) return 0;
    if (!personalAssumeMonthlyPercentage.value || parseFloat(personalAssumeMonthlyPercentage.value) <= 0) return 0;
    if (!drbPercentage.value || parseFloat(drbPercentage.value) <= 0) return 0;
    return new BigNumber(personalBuyInAmount.value).times(new BigNumber(drbDirectReferredPax.value)).div(100).times(new BigNumber(personalAssumeMonthlyPercentage.value)).div(100).times(drbPercentage.value).toNumber();
});
const drbMonthlyIncome = computed(() => {
    if (!drbMonthlyEarned.value || parseFloat(drbMonthlyEarned.value) <= 0) return 0;
    return new BigNumber(drbMonthlyEarned.value).plus(personalAssumeMonthlyIncome.value).toNumber();
});
const drbMonthlyPercentage = computed(() => {
    if (!drbMonthlyIncome.value || parseFloat(drbMonthlyIncome.value) <= 0) return 0;
    return new BigNumber(new BigNumber(drbMonthlyIncome.value)).div(new BigNumber(personalBuyInAmount.value)).times(100);
});

const bmbRankingSet = ref(1);
const bmbInvestorPax = ref('');
const bmbPercentage = computed(() => {
    let t = parseInt(bmbRankingSet.value);
    if (t === 3) return 5;
    else if (t === 2) return 4;
    else if (t === 1) return 3;
    else return 0;
});
const bmbMonthlyEarned = computed(() => {
    if (!bmbInvestorPax.value || parseFloat(bmbInvestorPax.value) <= 0) return 0;
    if (!bmbPercentage.value || parseFloat(bmbPercentage.value) <= 0) return 0;
    if (!personalAssumeMonthlyRoi.value || parseFloat(personalAssumeMonthlyRoi.value) <= 0) return 0;
    return new BigNumber(bmbInvestorPax.value).times(new BigNumber(personalAssumeMonthlyRoi.value)).div(100).times(new BigNumber(bmbPercentage.value)).toNumber();
});
const bmbMonthlyIncome = computed(() => {
    if (!bmbMonthlyEarned.value || parseFloat(bmbMonthlyEarned.value) <= 0) return 0;
    return new BigNumber(bmbMonthlyEarned.value).plus(new BigNumber(drbMonthlyIncome.value)).toNumber();
});
const bmbMonthlyPercentage = computed(() => {
    if (!bmbMonthlyIncome.value || parseFloat(bmbMonthlyIncome.value) <= 0) return 0;
    return new BigNumber(bmbMonthlyIncome.value).div(new BigNumber(personalBuyInAmount.value)).times(100).toNumber();
});

const bmiDirectReferredPax = ref('');
const bmiGensPax = ref('');
const bmiBmPerGenPax = ref('');
const bmiPercentage = computed(() => {
    if (!bmiDirectReferredPax.value || parseInt(bmiDirectReferredPax.value) <= 0) return 0;
    if (!bmiGensPax.value || parseInt(bmiGensPax.value) <= 0) return 0;
    if (!bmiBmPerGenPax.value || parseInt(bmiBmPerGenPax.value) <= 0) return 0;
    if (bmbRankingSet.value >= 3) {
        return 20;
    } else if (bmbRankingSet.value === 2) {
        return 15;
    } else if (bmbRankingSet.value === 1) {
        return 10;
    }
    return 0;
});
const bmiMonthlyEarned = computed(() => {
    if (!bmiPercentage.value || parseFloat(bmiPercentage.value) <= 0) return 0;
    return new BigNumber(bmiDirectReferredPax.value).times(Math.pow(bmiBmPerGenPax.value, bmiGensPax.value)).times(new BigNumber(bmbMonthlyEarned.value).plus(new BigNumber(drbMonthlyEarned.value))).div(100).times(bmiPercentage.value).toNumber();
});
const bmiMonthlyIncome = computed(() => {
    if (!bmiMonthlyEarned.value || parseFloat(bmiMonthlyEarned.value) <= 0) return 0;
    return new BigNumber(bmiMonthlyEarned.value).plus(bmbMonthlyIncome.value).toNumber();
});
const bmiYearlyIncome = computed(() => {
    if (!bmiMonthlyIncome.value || parseFloat(bmiMonthlyIncome.value) <= 0) return 0;
    return new BigNumber(bmiMonthlyIncome.value).times(12).toNumber();
});
</script>
